	AREA AddReg,CODE,READONLY	;Name this block of code.
	ENTRY 				;Mark first instruction to call.
Main
	ADR 	r0,ThumbProg +1 	;Generate branch target address
					;and set bit 0,hence arrive
					;at target in Thumb state.
	BX	r0 			;Branch exchange to ThumbProg.
	CODE16 				;Subsequent instructions are Thumb code.
ThumbProg
	MOV 	r2,#2 			;Load r2 with value 2.
	MOV 	r3,#3 			;Load r3 with value 3.
	ADD	r2,r2,r3	 	;r2 =r2 +r3
	ADR 	r0,ARMProg
	BX 	r0
	CODE32 				;Subsequent instructions are ARM code.
ARMProg
	MOV 	r4,#4
	MOV 	r5,#5
	ADD 	r4,r4,r5
Stop
 	MOV 	r0,#0x18 		;angel_SWIreason_ReportException
	LDR 	r1,=0x20026		;ADP_Stopped_ApplicationExit
	SWI 	0x123456 		;ARM semihosting SWI
	END 				;Mark end of this file.